/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../../../directory/xpcom/base/public/nsILDAPConnection.idl
 */

#ifndef __gen_nsILDAPConnection_h__
#define __gen_nsILDAPConnection_h__

#include "nsISupports.h"

#include "ldap.h"
class nsILDAPOperation; /* forward declaration */


/* starting interface:    nsILDAPConnection */
#define NS_ILDAPCONNECTION_IID_STR "337ad2fe-1dd2-11b2-89f8-aae1221ec86c"

#define NS_ILDAPCONNECTION_IID \
  {0x337ad2fe, 0x1dd2, 0x11b2, \
    { 0x89, 0xf8, 0xaa, 0xe1, 0x22, 0x1e, 0xc8, 0x6c }}

class NS_NO_VTABLE nsILDAPConnection : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ILDAPCONNECTION_IID)

  /**
     * the string version of lderrno
     */
  /* readonly attribute string errorString; */
  NS_IMETHOD GetErrorString(char * *aErrorString) = 0;

  /**
     * DN to bind as.  use the init() method to set this.
     *
     * @exception NS_ERROR_OUT_OF_MEMORY
     */
  /* readonly attribute string bindName; */
  NS_IMETHOD GetBindName(char * *aBindName) = 0;

  /** 
     * set up the connection.  
     *
     * @param aHost	 	server name for ldap_init()
     * @param aPort 		server port number for ldap_init()
     * @param aBindName 	DN to bind as
     *
     * @exception NS_ERROR_OUT_OF_MEMORY
     * @exception NS_ERROR_FAILURE
     * @exception NS_ERROR_NOT_AVAILABLE	Couldn't create thread.
     */
  /* void init (in string aHost, in short aPort, in string aBindName); */
  NS_IMETHOD Init(const char *aHost, PRInt16 aPort, const char *aBindName) = 0;

  /* long getLdErrno (out string matched, out string s); */
  NS_IMETHOD GetLdErrno(char **matched, char **s, PRInt32 *_retval) = 0;

  /**
     * really only for the internal use of nsLDAPOperation and friends
     * 
     * @exception NS_ERROR_INVALID_POINTER pointer passed in was NULL
     */
  /* [noscript] readonly attribute ldapConnectionHandle connectionHandle; */
  NS_IMETHOD GetConnectionHandle(LDAP * *aConnectionHandle) = 0;

  /** 
     * Add an nsILDAPOperation to the list of operations pending on
     * this connection.  This is also mainly intended for use by the
     * nsLDAPOperation code.  Used so that the thread waiting on messages
     * for this connection has an operation to callback to.
     *
     * @param aOperation		    operation to add
     * @exception NS_ERROR_INVALID_POINTER  aOperation was NULL
     * @exception NS_ERROR_UNEXPECTED	    this operation's msgId was not
     *	                                    unique to this connection
     * @exception NS_ERROR_OUT_OF_MEMORY    out of memory
     */
  /* void addPendingOperation (in nsILDAPOperation aOperation); */
  NS_IMETHOD AddPendingOperation(nsILDAPOperation *aOperation) = 0;

  /**
     * Remove an nsILDAPOperation from the list of operations pending on this
     * connection.  Mainly intended for use by the nsLDAPOperation code.
     *
     * @param aOperation	operation to add
     * @exception NS_ERROR_INVALID_POINTER  aOperation was NULL
     * @exception NS_ERROR_OUT_OF_MEMORY    out of memory
     * @exception NS_ERROR_FAILURE	    could not delete the operation 
     */
  /* void removePendingOperation (in nsILDAPOperation aOperation); */
  NS_IMETHOD RemovePendingOperation(nsILDAPOperation *aOperation) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSILDAPCONNECTION \
  NS_IMETHOD GetErrorString(char * *aErrorString); \
  NS_IMETHOD GetBindName(char * *aBindName); \
  NS_IMETHOD Init(const char *aHost, PRInt16 aPort, const char *aBindName); \
  NS_IMETHOD GetLdErrno(char **matched, char **s, PRInt32 *_retval); \
  NS_IMETHOD GetConnectionHandle(LDAP * *aConnectionHandle); \
  NS_IMETHOD AddPendingOperation(nsILDAPOperation *aOperation); \
  NS_IMETHOD RemovePendingOperation(nsILDAPOperation *aOperation); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSILDAPCONNECTION(_to) \
  NS_IMETHOD GetErrorString(char * *aErrorString) { return _to ## GetErrorString(aErrorString); } \
  NS_IMETHOD GetBindName(char * *aBindName) { return _to ## GetBindName(aBindName); } \
  NS_IMETHOD Init(const char *aHost, PRInt16 aPort, const char *aBindName) { return _to ## Init(aHost, aPort, aBindName); } \
  NS_IMETHOD GetLdErrno(char **matched, char **s, PRInt32 *_retval) { return _to ## GetLdErrno(matched, s, _retval); } \
  NS_IMETHOD GetConnectionHandle(LDAP * *aConnectionHandle) { return _to ## GetConnectionHandle(aConnectionHandle); } \
  NS_IMETHOD AddPendingOperation(nsILDAPOperation *aOperation) { return _to ## AddPendingOperation(aOperation); } \
  NS_IMETHOD RemovePendingOperation(nsILDAPOperation *aOperation) { return _to ## RemovePendingOperation(aOperation); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsLDAPConnection : public nsILDAPConnection
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSILDAPCONNECTION

  nsLDAPConnection();
  virtual ~nsLDAPConnection();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsLDAPConnection, nsILDAPConnection)

nsLDAPConnection::nsLDAPConnection()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsLDAPConnection::~nsLDAPConnection()
{
  /* destructor code */
}

/* readonly attribute string errorString; */
NS_IMETHODIMP nsLDAPConnection::GetErrorString(char * *aErrorString)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute string bindName; */
NS_IMETHODIMP nsLDAPConnection::GetBindName(char * *aBindName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void init (in string aHost, in short aPort, in string aBindName); */
NS_IMETHODIMP nsLDAPConnection::Init(const char *aHost, PRInt16 aPort, const char *aBindName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long getLdErrno (out string matched, out string s); */
NS_IMETHODIMP nsLDAPConnection::GetLdErrno(char **matched, char **s, PRInt32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] readonly attribute ldapConnectionHandle connectionHandle; */
NS_IMETHODIMP nsLDAPConnection::GetConnectionHandle(LDAP * *aConnectionHandle)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addPendingOperation (in nsILDAPOperation aOperation); */
NS_IMETHODIMP nsLDAPConnection::AddPendingOperation(nsILDAPOperation *aOperation)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removePendingOperation (in nsILDAPOperation aOperation); */
NS_IMETHODIMP nsLDAPConnection::RemovePendingOperation(nsILDAPOperation *aOperation)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsILDAPConnection_h__ */
