/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../../../directory/xpcom/base/public/nsILDAPMessage.idl
 */

#ifndef __gen_nsILDAPMessage_h__
#define __gen_nsILDAPMessage_h__

#include "nsISupports.h"
#include "nsILDAPOperation.h"

#include "ldap.h"

/* starting interface:    nsILDAPMessage */
#define NS_ILDAPMESSAGE_IID_STR "973ff50f-2002-4f0c-b57d-2242156139a2"

#define NS_ILDAPMESSAGE_IID \
  {0x973ff50f, 0x2002, 0x4f0c, \
    { 0xb5, 0x7d, 0x22, 0x42, 0x15, 0x61, 0x39, 0xa2 }}

class NS_NO_VTABLE nsILDAPMessage : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ILDAPMESSAGE_IID)

  /** 
     * Initializes a message.
     *
     * @param aConnection       The connection this message lives on.
     * @param aMsgHandle        The native LDAPMessage to be wrapped.
     * 
     * @exception NS_ERROR_INVALID_POINTER
     * @exception NS_ERROR_FAILURE              Err getting connection handle.
     */
  /* [noscript] void init (in nsILDAPConnection aConnection, in ldapMsgHandle aMsgHandle); */
  NS_IMETHOD Init(nsILDAPConnection *aConnection, LDAPMessage * aMsgHandle) = 0;

  /**
     * The Distinguished Name of the entry associated with this message.
     * Wrapper for ldap_get_dn().
     * 
     * @exception NS_ERROR_OUT_OF_MEMORY        ran out of memory
     * @exception NS_ERROR_ILLEGAL_VALUE        null pointer passed in
     * @exception NS_ERROR_LDAP_DECODING_ERROR  problem during BER-decoding
     * @exception NS_ERROR_UNEXPECTED           bug or memory corruption
     */
  /* readonly attribute string dn; */
  NS_IMETHOD GetDn(char * *aDn) = 0;

  /**
     * wrapper for ldap_{first,next}_attribute()
     *
     * @exception NS_ERROR_OUT_OF_MEMORY
     * @exception NS_ERROR_ILLEGAL_VALUE        null pointer passed in
     * @exception NS_ERROR_UNEXPECTED           bug or memory corruption
     * @exception NS_ERROR_LDAP_DECODING_ERROR  problem during BER decoding
     *
     * @return  array of all attributes in the current message
     */
  /* void getAttributes (out unsigned long count, [array, size_is (count), retval] out string aAttributes); */
  NS_IMETHOD GetAttributes(PRUint32 *count, char ***aAttributes) = 0;

  /**
     * wrapper for ldap_get_values()
     * 
     *
     * @param attr      The attribute whose values are to be returned
     * @param count     Number of values in the outbound array.
     * @param values    Array of values
     *
     * @exception NS_ERROR_UNEXPECTED           Bug or memory corruption
     * @exception NS_ERROR_LDAP_DECODING_ERROR  Attribute not found or other 
     *                                          decoding error.
     * @exception NS_ERROR_OUT_OF_MEMORY
     */
  /* void getValues (in string attr, out unsigned long count, [array, size_is (count), retval] out string values); */
  NS_IMETHOD GetValues(const char *attr, PRUint32 *count, char ***values) = 0;

  /* long getErrorCode (); */
  NS_IMETHOD GetErrorCode(PRInt32 *_retval) = 0;

  /* string toString (); */
  NS_IMETHOD ToString(char **_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSILDAPMESSAGE \
  NS_IMETHOD Init(nsILDAPConnection *aConnection, LDAPMessage * aMsgHandle); \
  NS_IMETHOD GetDn(char * *aDn); \
  NS_IMETHOD GetAttributes(PRUint32 *count, char ***aAttributes); \
  NS_IMETHOD GetValues(const char *attr, PRUint32 *count, char ***values); \
  NS_IMETHOD GetErrorCode(PRInt32 *_retval); \
  NS_IMETHOD ToString(char **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSILDAPMESSAGE(_to) \
  NS_IMETHOD Init(nsILDAPConnection *aConnection, LDAPMessage * aMsgHandle) { return _to ## Init(aConnection, aMsgHandle); } \
  NS_IMETHOD GetDn(char * *aDn) { return _to ## GetDn(aDn); } \
  NS_IMETHOD GetAttributes(PRUint32 *count, char ***aAttributes) { return _to ## GetAttributes(count, aAttributes); } \
  NS_IMETHOD GetValues(const char *attr, PRUint32 *count, char ***values) { return _to ## GetValues(attr, count, values); } \
  NS_IMETHOD GetErrorCode(PRInt32 *_retval) { return _to ## GetErrorCode(_retval); } \
  NS_IMETHOD ToString(char **_retval) { return _to ## ToString(_retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsLDAPMessage : public nsILDAPMessage
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSILDAPMESSAGE

  nsLDAPMessage();
  virtual ~nsLDAPMessage();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsLDAPMessage, nsILDAPMessage)

nsLDAPMessage::nsLDAPMessage()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsLDAPMessage::~nsLDAPMessage()
{
  /* destructor code */
}

/* [noscript] void init (in nsILDAPConnection aConnection, in ldapMsgHandle aMsgHandle); */
NS_IMETHODIMP nsLDAPMessage::Init(nsILDAPConnection *aConnection, LDAPMessage * aMsgHandle)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute string dn; */
NS_IMETHODIMP nsLDAPMessage::GetDn(char * *aDn)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getAttributes (out unsigned long count, [array, size_is (count), retval] out string aAttributes); */
NS_IMETHODIMP nsLDAPMessage::GetAttributes(PRUint32 *count, char ***aAttributes)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getValues (in string attr, out unsigned long count, [array, size_is (count), retval] out string values); */
NS_IMETHODIMP nsLDAPMessage::GetValues(const char *attr, PRUint32 *count, char ***values)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long getErrorCode (); */
NS_IMETHODIMP nsLDAPMessage::GetErrorCode(PRInt32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* string toString (); */
NS_IMETHODIMP nsLDAPMessage::ToString(char **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsILDAPMessage_h__ */
