/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../../../directory/xpcom/base/public/nsILDAPOperation.idl
 */

#ifndef __gen_nsILDAPOperation_h__
#define __gen_nsILDAPOperation_h__

#include "nsISupports.h"
#include "nsILDAPConnection.h"

class nsILDAPMessage; /* forward declaration */

class nsILDAPMessageListener; /* forward declaration */

typedef PRUint32 PRIntervalTime;


/* starting interface:    nsILDAPOperation */
#define NS_ILDAPOPERATION_IID_STR "fd3d413b-14b0-49c4-8348-a4fc0edba9ff"

#define NS_ILDAPOPERATION_IID \
  {0xfd3d413b, 0x14b0, 0x49c4, \
    { 0x83, 0x48, 0xa4, 0xfc, 0x0e, 0xdb, 0xa9, 0xff }}

class NS_NO_VTABLE nsILDAPOperation : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ILDAPOPERATION_IID)

  /**
     * The connection this operation is on. 
     */
  /* readonly attribute nsILDAPConnection connection; */
  NS_IMETHOD GetConnection(nsILDAPConnection * *aConnection) = 0;

  /**
     * Callback for individual result messages related to this operation (set
     * by the init() method).  This is actually an nsISupports proxy object, 
     * as the callback will happen from another thread.
     */
  /* readonly attribute nsILDAPMessageListener messageListener; */
  NS_IMETHOD GetMessageListener(nsILDAPMessageListener * *aMessageListener) = 0;

  /**
     * The message-id associated with this operation.
     *
     * @exception NS_ERROR_INVALID_POINTER      if a NULL pointer is passed in
     */
  /* readonly attribute long messageId; */
  NS_IMETHOD GetMessageId(PRInt32 *aMessageId) = 0;

  /**
     * Initializes this operation.  Must be called prior to initiating
     * any actual operations.  Note that by default, the aMessageListener
     * callbacks happen on the LDAP connection thread.  If you need them
     * to happen on the main thread (or any other thread), then you should
     * created an nsISupports proxy object and pass that in.
     *
     * @param aConnection       connection this operation should use
     * @param aMessageListener  interface used to call back the results.
     *
     * @exception NS_ERROR_INVALID_POINTER
     * @exception NS_ERROR_FAILURE		failed to get connection handle
     */
  /* void init (in nsILDAPConnection aConnection, in nsILDAPMessageListener aMessageListener); */
  NS_IMETHOD Init(nsILDAPConnection *aConnection, nsILDAPMessageListener *aMessageListener) = 0;

  /**
     * wrapper for ldap_simple_bind()
     * 
     * @param passwd    the password used for binding; NULL for anon-binds
     */
  /* void simpleBind (in string passwd); */
  NS_IMETHOD SimpleBind(const char *passwd) = 0;

  /* void urlSearch (in string url, in boolean attrsonly); */
  NS_IMETHOD UrlSearch(const char *url, PRBool attrsonly) = 0;

  /**
     * wrapper for ldap_search_ext(): kicks off an async search request.
     *
     * @param aBaseDn           Base DN to search
     * @param aScope            One of LDAP_SCOPE_{BASE,ONELEVEL,SUBTREE}
     * @param aFilter           Search filter
     * @param aTimeOut          How long to wait
     * @param aSizeLimit        Maximum number of entries to return.
     *
     * @exception NS_ERROR_ILLEGAL_VALUE
     * @exception NS_ERROR_LDAP_ENCODING_ERROR
     * @exception NS_ERROR_LDAP_SERVER_DOWN
     * @exception NS_ERROR_OUT_OF_MEMORY
     * @exception NS_ERROR_LDAP_NOT_SUPPORTED
     *
     * XXX doesn't currently handle LDAPControl params
     */
  /* void searchExt (in string aBaseDn, in PRInt32 aScope, in string aFilter, in PRIntervalTime aTimeOut, in PRInt32 aSizeLimit); */
  NS_IMETHOD SearchExt(const char *aBaseDn, PRInt32 aScope, const char *aFilter, PRIntervalTime aTimeOut, PRInt32 aSizeLimit) = 0;

  /**  
     * wrapper for ldap_abandon_ext() with NULL LDAPControl
     * parameters, equivalent to old-style ldap_abandon(), thus the name.
     *
     * @exception NS_ERROR_ILLEGAL_VALUE  	an argument was invalid
     * @exception NS_ERROR_LDAP_ENCODING_ERROR  error during BER-encoding
     * @exception NS_ERROR_LDAP_SERVER_DOWN	the LDAP server did not
     *						receive	the request or the
     *						connection was lost
     * @exception NS_ERROR_OUT_OF_MEMORY	out of memory
     * @exception NS_ERROR_UNEXPECTED		internal error
     */
  /* void abandon (); */
  NS_IMETHOD Abandon(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSILDAPOPERATION \
  NS_IMETHOD GetConnection(nsILDAPConnection * *aConnection); \
  NS_IMETHOD GetMessageListener(nsILDAPMessageListener * *aMessageListener); \
  NS_IMETHOD GetMessageId(PRInt32 *aMessageId); \
  NS_IMETHOD Init(nsILDAPConnection *aConnection, nsILDAPMessageListener *aMessageListener); \
  NS_IMETHOD SimpleBind(const char *passwd); \
  NS_IMETHOD UrlSearch(const char *url, PRBool attrsonly); \
  NS_IMETHOD SearchExt(const char *aBaseDn, PRInt32 aScope, const char *aFilter, PRIntervalTime aTimeOut, PRInt32 aSizeLimit); \
  NS_IMETHOD Abandon(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSILDAPOPERATION(_to) \
  NS_IMETHOD GetConnection(nsILDAPConnection * *aConnection) { return _to ## GetConnection(aConnection); } \
  NS_IMETHOD GetMessageListener(nsILDAPMessageListener * *aMessageListener) { return _to ## GetMessageListener(aMessageListener); } \
  NS_IMETHOD GetMessageId(PRInt32 *aMessageId) { return _to ## GetMessageId(aMessageId); } \
  NS_IMETHOD Init(nsILDAPConnection *aConnection, nsILDAPMessageListener *aMessageListener) { return _to ## Init(aConnection, aMessageListener); } \
  NS_IMETHOD SimpleBind(const char *passwd) { return _to ## SimpleBind(passwd); } \
  NS_IMETHOD UrlSearch(const char *url, PRBool attrsonly) { return _to ## UrlSearch(url, attrsonly); } \
  NS_IMETHOD SearchExt(const char *aBaseDn, PRInt32 aScope, const char *aFilter, PRIntervalTime aTimeOut, PRInt32 aSizeLimit) { return _to ## SearchExt(aBaseDn, aScope, aFilter, aTimeOut, aSizeLimit); } \
  NS_IMETHOD Abandon(void) { return _to ## Abandon(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsLDAPOperation : public nsILDAPOperation
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSILDAPOPERATION

  nsLDAPOperation();
  virtual ~nsLDAPOperation();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsLDAPOperation, nsILDAPOperation)

nsLDAPOperation::nsLDAPOperation()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsLDAPOperation::~nsLDAPOperation()
{
  /* destructor code */
}

/* readonly attribute nsILDAPConnection connection; */
NS_IMETHODIMP nsLDAPOperation::GetConnection(nsILDAPConnection * *aConnection)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsILDAPMessageListener messageListener; */
NS_IMETHODIMP nsLDAPOperation::GetMessageListener(nsILDAPMessageListener * *aMessageListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long messageId; */
NS_IMETHODIMP nsLDAPOperation::GetMessageId(PRInt32 *aMessageId)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void init (in nsILDAPConnection aConnection, in nsILDAPMessageListener aMessageListener); */
NS_IMETHODIMP nsLDAPOperation::Init(nsILDAPConnection *aConnection, nsILDAPMessageListener *aMessageListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void simpleBind (in string passwd); */
NS_IMETHODIMP nsLDAPOperation::SimpleBind(const char *passwd)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void urlSearch (in string url, in boolean attrsonly); */
NS_IMETHODIMP nsLDAPOperation::UrlSearch(const char *url, PRBool attrsonly)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void searchExt (in string aBaseDn, in PRInt32 aScope, in string aFilter, in PRIntervalTime aTimeOut, in PRInt32 aSizeLimit); */
NS_IMETHODIMP nsLDAPOperation::SearchExt(const char *aBaseDn, PRInt32 aScope, const char *aFilter, PRIntervalTime aTimeOut, PRInt32 aSizeLimit)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void abandon (); */
NS_IMETHODIMP nsLDAPOperation::Abandon()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsILDAPOperation_h__ */
